/// Annotations used for generated classes to give them metadata
abstract class NowaAnnotation {
  const NowaAnnotation({this.name, this.loader});

  final String? name;
  final String? loader;
}

class NowaVar extends NowaAnnotation {
  const NowaVar({super.name, this.key, super.loader});
  final String? key;
}

class NowaFunc extends NowaAnnotation {
  const NowaFunc({super.name, super.loader});
}

class NowaClass extends NowaAnnotation {
  const NowaClass({super.name, super.loader});
}

class NowaGenerated {
  const NowaGenerated([this.metadata = const {}]);

  final Map<String, dynamic> metadata;
}

class CustomFunction {
  const CustomFunction({this.preview, this.imports});

  final String? preview;
  final List<String>? imports;
}

class CustomWidget {
  const CustomWidget({this.preview, this.imports});

  final String? preview;
  final List<String>? imports;
}
