import 'package:chewie/chewie.dart';
import 'package:flutter/material.dart';
import 'package:nowa_runtime/nowa_runtime.dart';

class NowaVideoPlayer extends StatefulWidget {
  const NowaVideoPlayer({required this.controller, super.key});

  final NowaVideoPlayerController controller;

  @override
  State<NowaVideoPlayer> createState() => _NowaVideoPlayerState();
}

class _NowaVideoPlayerState extends State<NowaVideoPlayer> {
  bool isLoading = true;
  bool initializingDoneFine = true;

  @override
  void initState() {
    super.initState();
    widget.controller.initialize(context).then((initializingDoneFine) {
      setState(() {
        isLoading = false;
        initializingDoneFine = initializingDoneFine;
      });
    });
  }

  @override
  void didUpdateWidget(covariant NowaVideoPlayer oldWidget) {
    if (oldWidget.controller != widget.controller) {
      widget.controller.initialize(context);
    }
    super.didUpdateWidget(oldWidget);
  }

  @override
  void dispose() {
    widget.controller.dispose();
    super.dispose();
  }

  @override
  Widget build(BuildContext context) {
    if (isLoading) {
      return const Center(child: CircularProgressIndicator());
    } else {
      if (!initializingDoneFine) {
        return const Center(child: Text('Error initializing video player'));
      }
      if (widget.controller.chewieController == null) {
        return const Center(child: Text('Error : no video player controller found'));
      } else {
        return Chewie(
          controller: widget.controller.chewieController!,
        );
      }
    }
  }
}
